process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean error;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(OK,a,b,c) |)/ C_OK
                                         / stable
                                         / C_err
                                         / C_y
                                         / C_x
       | (| FirstDegree_ABS(not OK,b,c) |)/ C_cc1
                                          / C_error
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   boolean err2, err, C_x, C_y, C_err, stable, C_OK, OK, C_bb, C_error, C_cc1;
   process FirstDegree_ABS =
        ( ? boolean Compute;
            real b, c;
          ! real x;
            boolean err2, C_bb, C_error;
        )
      pragmas 
         Grey_Box "FirstDegree"
      end pragmas
      (| (| Tick := true
          | when Tick ^= Compute ^= b ^= c
          | when Compute ^= C_bb ^= C_error
          | when C_bb ^= x
          | when C_error ^= err2
          |)
       | (| nlabel :: (x,err2) := FirstDegree_Cluster_1(Compute)
          | nlabel ^= when Compute
          |)
       | (| nlabel_65 :: FirstDegree_Cluster_2(Compute,c)
          | nlabel_65 ^= when Tick
          |)
       | (| nlabel_66 :: (C_bb,C_error) := FirstDegree_Cluster_3(Compute,b)
          | nlabel_66 ^= when Tick
          |)
       | (| nlabel_65 --> nlabel
          | c --> nlabel_65
          | Compute --> nlabel_65
          | nlabel_66 --> nlabel
          | b --> nlabel_66
          | Compute --> nlabel_66
          |)
       |)
      where 
      boolean Tick;
      label nlabel, nlabel_65, nlabel_66; 
      action FirstDegree_Cluster_1 =
           ( ? boolean Compute;
             ! real x;
               boolean err2;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action FirstDegree_Cluster_2 =
           ( ? boolean Compute;
               real c;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      action FirstDegree_Cluster_3 =
           ( ? boolean Compute;
               real b;
             ! boolean C_bb;
               boolean C_error;
           )
         pragmas 
            Black_Box ""
         end pragmas
      
      ; 
      end
   ; 
   process SecondDegree_ABS =
        ( ? boolean OK;
            real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable, C_y, C_OK, C_err, C_x;
        )
      pragmas 
         Grey_Box "SecondDegree"
      end pragmas
      (| (| Tick1 := true
          | when Tick1 ^= stable ^= C_y ^= C_x
          | when OK ^= C_err
          | when stable ^= a ^= b ^= c ^= C_OK
          | when C_y ^= x2
          | when C_OK ^= OK
          | when C_err ^= err
          | when C_x ^= x21
          |)
       | (| nlabel :: (err,x21,x2,C_y,C_err,C_x) := SecondDegree_Cluster_1(OK)
          | nlabel ^= when Tick1
          |)
       | (| nlabel_994 :: SecondDegree_Cluster_2(OK,b)
          | nlabel_994 ^= when stable
          |)
       | (| nlabel_995 :: SecondDegree_Cluster_3(OK,c)
          | nlabel_995 ^= when stable
          |)
       | (| nlabel_996 :: SecondDegree_Cluster_4(OK,a)
          | nlabel_996 ^= when Tick1
          |)
       | (| nlabel_997 :: C_OK := SecondDegree_Cluster_5(a)
          | nlabel_997 ^= when Tick1
          |)
       | (| nlabel_1030 :: stable := SecondDegree_Cluster_delays()
          | nlabel_1030 ^= when Tick1
          |)
       | (| c --> nlabel
          | b --> nlabel
          | a --> nlabel
          | OK --> nlabel
          | nlabel_994 --> nlabel
          | b --> nlabel_994
          | OK --> nlabel_994
          | nlabel_995 --> nlabel
          | c --> nlabel_995
          | OK --> nlabel_995
          | nlabel_996 --> nlabel_995
          | nlabel_996 --> nlabel_994
          | nlabel_996 --> nlabel
          | a --> nlabel_996
          | OK --> nlabel_996
          | nlabel_997 --> nlabel_996
          | nlabel_997 --> nlabel
          | a --> nlabel_997
          | nlabel_997 --> nlabel_1030
          | nlabel_996 --> nlabel_1030
          | nlabel_995 --> nlabel_1030
          | nlabel_994 --> nlabel_1030
          | nlabel --> nlabel_1030
          |)
       |)
      where 
      boolean Tick1;
      label nlabel, nlabel_994, nlabel_995, nlabel_996, nlabel_997, nlabel_1030; 
      action SecondDegree_Cluster_1 =
           ( ? boolean OK;
             ! boolean err;
               real x21;
               real x2;
               boolean C_y;
               boolean C_err;
               boolean C_x;
           )
         pragmas 
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_2 =
           ( ? boolean OK;
               real b;
           )
         pragmas 
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_3 =
           ( ? boolean OK;
               real c;
           )
         pragmas 
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_4 =
           ( ? boolean OK;
               real a;
           )
         pragmas 
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_5 =
           ( ? real a;
             ! boolean C_OK;
           )
         pragmas 
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      action SecondDegree_Cluster_delays =
           ( ! boolean stable init true;
           )
         pragmas 
            DelayCluster
            Cluster
            Black_Box ""
         end pragmas
         external "C"
      ; 
      end
   ; 
   real x21, x;
   end
; 
