process coSimClu =
     ( ? real a;
         real b;
         real c;
       ! real x1;
         real x2;
         boolean error;
         integer lat;
         integer MaxLat;
     )
   pragmas 
      main
      Defined_clock_hierarchy
   end pragmas
   (| (| DateGenerator{}
       | (| d_deb := d_c
          | Latency{}
          |) where HomoType d_deb; end
       | MaxLatency{}
       | P_COSTP{}
       |)/ d_error, d_x1, d_x2, stable, dEnd, d_c, d_b, d_a |)
   where 
   use Cost_Context, STD, COSTBIB, M_P_COST; 
   process DateGenerator =
        ( ? dEnd;
          ! d_a;
            HomoType d_b;
            HomoType d_c;
        )
      (| d := ((dEnd$ init NilHomoTypeValue) when (^d_a))+(d$ init NilHomoTypeValue)
       | d_a := d
       | d_b := d
       | d_c := d
       |)
      where 
      HomoType d;
      end
   %DateGenerator%; 
   process MaxLatency =
        ( ? HomoType lat;
          ! HomoType MaxLat;
        )
      (| MaxLat := (lat when (lat>ZMaxLat)) default ZMaxLat
       | ZMaxLat := MaxLat$1 init NilHomoTypeValue
       | ZMaxLat ^= lat
       |)
      where 
      HomoType ZMaxLat;
      end
   %MaxLatency%; 
   process Latency =
        ( ? d_deb;
            boolean stable;
            HomoType d_x1;
            HomoType d_x2;
            HomoType d_error;
          ! HomoType dEnd;
            HomoType lat;
        )
      (| d_end := MAX(MAX(d_x1,d_x2),d_error)
       | dEnd := d_end cell (^stable)
       | l := dEnd-(d_deb cell (^stable))
       | lat := l when (^d_end)
       |)
      where 
      HomoType l, d_end;
      process MAX =
           ( ? HomoType IN1;
               HomoType IN2;
             ! HomoType MAX_VAL;
           )
         (| HCOMMON := (when (^IN1)) when (^IN2)
          | c1 := IN1 when HCOMMON
          | c2 := IN2 when HCOMMON
          | MAX_VAL := (IN1 when (c1>c2)) default IN2 default IN1
          |)
         where 
         event HCOMMON;
         HomoType c1, c2;
         end
      %MAX%; 
      end
   %Latency%; 
   process P_COSTP =
        ( ? real a;
            real b;
            real c;
            HomoType d_a;
            HomoType d_b;
            HomoType d_c;
          ! real x2;
            real x1;
            boolean error;
            boolean stable init true;
            HomoType d_x2;
            HomoType d_x1;
            HomoType d_error;
        )
      (| (| P{}
          | P_COST{}%**ERROR: Identifier not declared : C_cc_384
            **ERROR: Identifier not declared : C_373
            **ERROR: Identifier not declared : err2
            %
          |)/ C_error, C_cc_381, C_370, C_, C_d, C_331, OK, C_328, error_224, next_stable |)
      where 
      boolean error_224, next_stable, OK, C_d, C_, C_328, C_331, C_370, C_cc_381, C_error;
      process P =
           ( ? real a, b, c;
             ! real x2, x1;
               boolean error, OK, stable init true, next_stable, error_224, C_328, C_331, C_d, C_, C_370, C_cc_381, C_error;
           )
         pragmas 
            main
         end pragmas
         (| (| Tick := true
             | when Tick ^= stable ^= yy ^= mx ^= next_stable ^= s ^= x_147 ^= C_328 ^= C_331 ^= C_d_354 ^= C__365
             | when Tick ^= next_yy ^= biterate ^= XZX_134 ^= C ^= C_y ^= OK_344 ^= C_cc_387 ^= C__413 ^= C_x ^= C_x1 ^= C_434 ^= C_438 ^= C_442
             |)
          | (| when stable ^= C_err
             | when stable ^= a ^= b ^= c ^= OK ^= C_cc ^= C_373 ^= C_error_395
             |)
          | (| when OK ^= bb ^= cc ^= dd ^= aa ^= XZX ^= XZX_84 ^= C_d ^= C_ ^= C_370 |)
          | (| when C_d ^= d |)
          | (| when C_ ^= x_88 ^= XZX_91 |)
          | (| when C_cc ^= bb_229 ^= cc_230 ^= C_cc_381 ^= C_error |)
          | (| when C_cc_381 ^= x ^= bb_212 ^= cc_213 |)
          | (| when C_error ^= error_224 |)
          | (| when C_err ^= error ^= err_235 |)
          | (| nlabel_447 :: equationSolving_Cluster_4{}
             | nlabel_447 ^= when stable
             |)
          | (| when C_y ^= x2 ^= y ^= bb_110 ^= x_168 ^= x_177 |)
          | (| when C__413 ^= XZX_164 |)
          | (| when C_x ^= x_186 |)
          | (| when C_x1 ^= x1 |)
          | (| nlabel :: equationSolving_Cluster_1{}
             | nlabel ^= when Tick
             |)
          | (| nlabel_445 :: equationSolving_Cluster_2{}
             | nlabel_445 ^= when Tick
             |)
          | (| nlabel_446 :: equationSolving_Cluster_3{}
             | nlabel_446 ^= when Tick
             |)
          | (| nlabel_468 :: equationSolving_Cluster_delays{}
             | nlabel_468 ^= when Tick
             |)
          | (| c --> nlabel_447
             | b --> nlabel_446
             | a --> nlabel_445
             | nlabel_447 --> nlabel
             | nlabel_446 --> nlabel
             | nlabel_445 --> nlabel
             | nlabel_445 --> nlabel_446
             | nlabel_445 --> nlabel_447
             |)
          |)
         where 
         constant real cst_epsilon = 0.00001;
         label nlabel, nlabel_445, nlabel_446, nlabel_468; 
         label nlabel_447; 
         process equationSolving_Cluster_4 =
              ( ? real c;
                  boolean OK, stable;
                  real aa;
                  boolean C_cc;
              )
            pragmas 
               Cluster
            end pragmas
            (| (| (| cc := XZX_84/aa
                   | XZX_84 := c when OK
                   | cc_230 := c when C_cc
                   |) |) |)
         %equationSolving_Cluster_4%; 
         process equationSolving_Cluster_1 =
              ( ? boolean OK;
                  real bb, cc;
                  boolean stable;
                  real XZX_134, bb_212, cc_230;
                  boolean OK_344, C_cc, C_cc_381, C_cc_387, C_error, C_error_395;
                ! real x2, x1;
                  boolean error;
              )
            pragmas 
               Cluster
            end pragmas
            (| (| (| error := err_235
                   | biterate := (true when C_d) default ((not stable) when C_434)
                   | next_stable := s<cst_epsilon
                   | error_224 := (cc_230/=0.0) when C_error
                   | err_235 := (true when C_370) default (error_224 when C_error)
                   | C := not biterate
                   | C_328 := x_147>=0.0
                   | C_331 := not (x_147>=0.0)
                   | C_y := next_stable and biterate
                   | C_d := dd>0.0
                   | C_d_354 := left_tt(C_d,stable)
                   | C_ := dd=0.0
                   | C__365 := left_tt(C_,stable)
                   | C_370 := dd<0.0
                   | C_373 := left_tt(C_370,OK)
                   | C__413 := C_y or OK_344
                   | C_x := C_y or C__365
                   | C_err := C_373 or C_error_395
                   | C_x1 := C_x or C_cc_387
                   | C_434 := not C_d_354
                   | C_438 := (not C_y) and C__365
                   | C_442 := (not C_x) and C_cc_387
                   |)
                | (| x2 := x_168
                   | x1 := (x_186 when C_x) default (x when C_442)
                   | x := -(cc_213/bb_212)
                   | d := dd when C_d
                   | dd := (bb*bb)-(4.0*cc)
                   | x_88 := (-XZX_91)/2.0
                   | XZX_91 := bb when C_
                   | y := yy when C_y
                   | bb_110 := XZX_164 when C_y
                   | yy := ((d/2.0) when C_d) default (XZX_134 when C_434)
                   | next_yy := (((yy+(mx/yy))/2.0) when biterate) default (yy when C)
                   | mx := (d when C_d) cell Tick init 0.0e0
                   | s := (x_147 when C_328) default ((-x_147) when C_331)
                   | x_147 := next_yy-yy
                   | XZX_164 := (bb when OK) cell C__413 init 0.0e0
                   | x_168 := -((bb_110-y)/2.0)
                   | x_177 := -((bb_110+y)/2.0)
                   | x_186 := (x_177 when C_y) default (x_88 when C_438)
                   | cc_213 := cc_230 when C_cc_381
                   |)
                |) |)
         %equationSolving_Cluster_1%; 
         process equationSolving_Cluster_2 =
              ( ? real a;
                  boolean stable;
              )
            pragmas 
               Cluster
            end pragmas
            (| (| (| OK := a/=0.0
                   | OK_344 := left_tt(OK,stable)
                   | C_cc := not OK
                   |)
                | (| aa := a when OK |)
                |) |)
         %equationSolving_Cluster_2%; 
         process equationSolving_Cluster_3 =
              ( ? real b;
                  boolean OK, stable;
                  real aa;
                  boolean C_cc;
              )
            pragmas 
               Cluster
            end pragmas
            (| (| (| C_cc_381 := bb_229/=0.0
                   | C_cc_387 := left_tt(C_cc_381,stable)
                   | C_error := bb_229=0.0
                   | C_error_395 := left_tt(C_error,C_cc)
                   |)
                | (| bb := XZX/aa
                   | XZX := b when OK
                   | bb_212 := bb_229 when C_cc_381
                   | bb_229 := b when C_cc
                   |)
                |) |)
         %equationSolving_Cluster_3%; 
         process equationSolving_Cluster_delays =
              ( ? real next_yy;
                  boolean next_stable;
              )
            pragmas 
               DelayCluster
               Cluster
            end pragmas
            (| (| (| stable := next_stable$1 init true |)
                | (| XZX_134 := next_yy$1 init 1.0 |)
                |) |)
         %equationSolving_Cluster_delays%; 
         real x, bb, cc, d, dd, aa, XZX, XZX_84, x_88, XZX_91, y, bb_110, yy, next_yy;
         boolean biterate;
         real mx, XZX_134, s, x_147, XZX_164, x_168, x_177, x_186, bb_212, cc_213, bb_229, cc_230;
         boolean err_235, Tick, C, C_y, OK_344, C_cc, C_d_354, C__365, C_373, C_cc_387, C_error_395, C__413, C_x, C_err, C_x1, C_434, C_438, C_442;
         end
      %P%; 
      end
   %P_COSTP%; 
   HomoType d_a, d_b, d_c, dEnd, d_x2, d_x1, d_error;
   boolean stable init true;
   end
%coSimClu%; 
